//---------------------------------------------------------------------------

#pragma hdrstop

//---------------------------------------------------------------------------

#include <iostream>

template <typename T>
class projection
{
   T t;
public:
   template <typename S>
   explicit projection(S const &s)
   {
      t = static_cast<T>(s);
      // the place for a warning (i.e., sent to 'std::cerr').
   }
   template <typename S>
   operator S()
   {
      return static_cast<S>(t);
   }

   typedef T internal_type;
};

template <>
class projection<double>
{
   double t;
public:
   template <typename S>
   explicit projection(S const &s)
   {
      t = static_cast<double>(s);
   }
   template <typename S>
   operator S()
   {
      return static_cast<S>(t);
   }
   typedef double internal_type;
};

template <>
template <>
projection<double>::operator float()
{
   return static_cast<float>(t);
}

template <typename T>
projection<T>::internal_type sqr(T value)
{
   typename projection<T>::internal_type res = value;
   return res * res;
}

#pragma argsused
int main(int argc, char* argv[])
{
   double d = 1234.202;
   projection<float>::internal_type f = 4321.02;

   std::cout << sqr(f) << std::endl; 

   std::cout << "A deficit: "
             << d - projection<int>(d).operator double()    << std::endl
             << d - projection<double>(d).operator double() << std::endl
             << f - projection<double>(f).operator float()  << std::endl
             << std::endl;
   return 0;
}
//---------------------------------------------------------------------------
 