#include <exception>
#include <iostream>
#include <string>
#include <typeinfo>

using namespace std;

class base
{
   static string const name;
public:
   virtual string const &class_name() const  {  return name;   }
   virtual ~base()                           {             ;   }

   friend ostream &operator <<(ostream &, base const &);
};

string const base::name = "Base";

class first_derivative: public base
{
   static string const name;
public:
   virtual string const &class_name() const  {  return name;   }
   virtual ~first_derivative()               {             ;   }

   friend ostream &operator <<(ostream &, base const &);
};

string const first_derivative::name = "First derivative";

class second_derivative: public first_derivative
{
   static string const name;
public:
   virtual  string const &class_name() const {  return name;  }
   string   try_to_call_me()           const {  return name;  }
   virtual ~second_derivative()              {             ;  }

   friend ostream &operator <<(ostream &, base const &);
};

string const second_derivative::name = "Second derivative";

class third_derivative: public second_derivative   {};

inline
ostream &operator <<(ostream &os, base const &b)
{
   return os << b.class_name();
}

inline
void print(base const *b)
{
   cout << *b << endl;
}

int main(int, char * const[])
{
   base const *b;

   b = new base;
   print(b);
   cout << *b;
   delete b;

   b = new first_derivative;
   print(b);
   cout << *b;
   delete b;

   b = new second_derivative;
   print(b);
   cout << *b;
   delete b;

   // but also...
   b = new second_derivative;
   try
   {
   // throws a 'bad_cast' exception
   // third_derivative const &d = dynamic_cast<third_derivative const &>(*b);
      second_derivative const &d = dynamic_cast<second_derivative const &>(*b);
      cout << d
           << endl;
   }
   catch(bad_cast &bc)
   {
      cerr << "Bad cast exception occured: " << bc.what() << endl;
   }
   catch(...)
   {
      cerr << "Ufff, something really went astray!";
   }
   delete b;
   return 0;
}
