//The example works under g++ 3.0.3
#include <iostream>

using std::ostream;
using std::cout;
using std::endl;

template <typename T>
class streamable;

template <typename S, typename T>
S &friend_fun(S &, streamable<T> &);

template <typename S, typename T>
S &operator <<(S &, streamable<T> &);
///

template <typename T>
class streamable                         
{
public:
   T table[0x20];
public:
   streamable()   {  }

   // <constructors>
   template <typename S>
   streamable(S const &);

   template <typename S>
   streamable(streamable<S> const &);
   // </constructors>

   template <typename S, typename TT>
   friend
   S &friend_fun(S &, streamable<TT> &);

   template <typename S, typename TT>
   friend
   S &operator <<(S &, streamable<TT> &);

   T operator [](int index) const  {  return table[index];  }
};


// generic constructor
template <typename T>
template <typename S>
streamable<T>::streamable(S const &s)
{
   for(int i = 0; table[i] = s[i], i<0x20; ++i);
}

// more specialized one
template <typename T>
template <typename S>
streamable<T>::streamable(streamable<S> const &s)
{
   for(int i = 0; table[i] = s[i], i<0x20; ++i);
}

// friends
template <typename S, typename T>
S &friend_fun(S &s, streamable<T> &st)
{
   for(int i = 0; s<<st.table[i], i<0x20; ++i);
   return s;
}

template <typename S, typename T>
S &operator <<(S &s, streamable<T> &st)
{
   for(int i = 0; s<<st.table[i], i<0x20; ++i);
   return s;
}

// aliens
template <typename S, typename T>
S &fun(S &s, streamable<T> &st)
{
   for(int i = 0; s<<st[i], i<0x20; ++i);
   return s;
}

int main(int, char *[])
{
   streamable<int> istr;
   streamable<double> dstr = istr;

   friend_fun<ostream, int>(cout, istr);
//   friend_fun(cout, dstr);
   cout<<dstr;

   fun<ostream, int>(cout, istr);
   fun(cout, dstr);

   return 0;
}


