#pragma hdrstop

#include <algorithm>
#include <iostream>
#include <iterator>
#include <list>

inline
std::ostream &dings(std::ostream &os)
{
   return std::cout << " ************* \n";
}

template <typename T, int n>
struct __fibonacci
{
   enum { _n = __fibonacci<T, n - 1>::_n + __fibonacci<T, n - 2>::_n   };
};

template <typename T>
struct __fibonacci<T, 1>
{
   enum { _n = 1   };                
};

template <typename T>
struct __fibonacci<T, 0>
{
   enum { _n = 0   };
};

// caling facility
template <typename T, int n>
struct fibonacci
{
   T operator ()()   {  return __fibonacci<T, n>::_n; }
};

template <typename T, int n, template <typename T, int n> class _filler>
struct filler
{
   static T fill(T *a)
   {
      return *a = _filler<T, n>()(), filler<T, n - 1, _filler>::fill(a + 1);
   }
};

template <typename T, template <typename T> class _filler>
struct filler<T, 0, _filler>
{
   static T fill(T *a)
   {
      return *a = _filler<T, 0>()();
   }
};

template <class Iterator>
class a_wannabe_bidir_iterator: public
      std::iterator<std::bidirectional_iterator_tag, void, void, void, void>
{
protected:
   Iterator &iterator;
public:
   typedef  a_wannabe_bidir_iterator<Iterator> self_t;
   explicit self_t(Iterator &x): iterator(x) { ; }

   // a clue!
   template <typename T>
   self_t& operator =(T const &v)
   {
      return iterator = v, *this;
   }

   // these two make for the iterator a bidirectional interface...
   self_t &operator --()   { return *this; }
   self_t  operator --(int){ return *this; }

   // ... while the remainder is quite typical for 'fake' output iterators
   //     cf e.g. ostream_iterator<...> implementation
   self_t &operator ++()   { return *this; }
   self_t  operator ++(int){ return *this; }

   self_t &operator  *()   { return *this; }
};

template <class Iterator>
inline
a_wannabe_bidir_iterator<Iterator> wannabe_bidir_iterator(Iterator& x)
{
   return a_wannabe_bidir_iterator<Iterator>(x);
}

long tl[20];

int main(int, char *[])
{
   using std::copy_backward;
   using std::cout;
   using std::ostream_iterator;

   filler<long, 20, fibonacci>::fill(tl);

   cout << dings;

   ostream_iterator<long, char> osi(cout << std::right, "\n");
   copy_backward(tl, tl + 20, wannabe_bidir_iterator(osi));

   cout << dings;
   return 0;
}
